
/*  A Bison parser, made from parse.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	CLASS	257
#define	FROM	258
#define	CONST	259
#define	VOID	260
#define	STRUCT	261
#define	UNION	262
#define	ENUM	263
#define	THREEDOTS	264
#define	SIGNED	265
#define	UNSIGNED	266
#define	LONG	267
#define	SHORT	268
#define	INT	269
#define	FLOAT	270
#define	DOUBLE	271
#define	CHAR	272
#define	ONERROR	273
#define	TOKEN	274
#define	NUMBER	275
#define	TYPETOKEN	276
#define	ARRAY_DIM	277
#define	CCODE	278
#define	HTCODE	279
#define	PHCODE	280
#define	HCODE	281
#define	PUBLIC	282
#define	PRIVATE	283
#define	PROTECTED	284
#define	ARGUMENT	285
#define	VIRTUAL	286
#define	SIGNAL	287
#define	OVERRIDE	288

#line 21 "parse.y"


#include "config.h"
#include <glib.h>
#include <stdio.h>
#include <string.h>

#include "tree.h"
#include "main.h"
#include "util.h"

#define _(x) (x)
	
GList *nodes = NULL;

static GList *class_nodes = NULL;
Node *class = NULL;

static GList *typestack = NULL;
static int stars = 0;
static GList *funcargs = NULL;
static GList *checks = NULL;
static int has_self = FALSE;
static int vararg = FALSE;

static GList *gtktypes = NULL;

/* this can be a global as we will only do one function at a time
   anyway */
static int the_scope = NO_SCOPE;

void free(void *ptr);
int yylex(void);

extern int ccode_line;
extern int line_no;

extern char *yytext;

static void
yyerror(char *str)
{
	char *out=NULL;
	char *p;
	
	if(strcmp(yytext,"\n")==0) {
		out=g_strconcat("Error: ",str," before newline",NULL);
	} else if(yytext[0]=='\0') {
		out=g_strconcat("Error: ",str," at end of input",NULL);
	} else {
		char *tmp = g_strdup(yytext);
		while((p=strchr(tmp,'\n')))
			*p='.';

		out=g_strconcat("Error: ",str," before '",tmp,"'",NULL);
		g_free(tmp);
	}

	fprintf(stderr,"%s:%d: %s\n",filename,line_no,out);
	g_free(out);
	
	exit(1);
}

static Type *
pop_type(void)
{
	Type *type = typestack->data;
	typestack = g_list_remove(typestack,typestack->data);
	return type;
}

static void
push_variable(char *name, int scope, int line_no, char *postfix)
{
	Node *var;
	Type *type = pop_type();

	type->postfix = postfix;
	
	var = new_variable(scope,type,name,line_no);
	class_nodes = g_list_append(class_nodes, var);
}

static void
push_function(int scope, int method, char *oid, char *id, char *onerror,
	      GString *cbuf,int line_no, int ccode_line, int vararg)
{
	Node *node;
	Type *type;
	char *c_cbuf;
       
	if(method!=INIT_METHOD && method!=CLASS_INIT_METHOD) {
		type = pop_type();
	} else {
		type = (Type *)new_type(0,g_strdup("void"),NULL);
	}
	
	/* a complicated and ugly test to figure out if we have
	   the wrong number of types for a signal */
	if((method == SIGNAL_FIRST_METHOD ||
	    method == SIGNAL_LAST_METHOD) &&
	   g_list_length(gtktypes) != g_list_length(funcargs) &&
	   !(g_list_length(funcargs) == 1 &&
	     g_list_length(gtktypes) == 2 &&
	     strcmp(gtktypes->next->data,"NONE")==0)) {
		print_error(TRUE, _("The number of GTK arguments and "
				    "function arguments for a signal "
				    "don't seem to match"),line_no);
	}
	if(cbuf) {
		char *p;
		c_cbuf = p = cbuf->str;
		while(p && *p && (*p==' ' || *p=='\t' || *p=='\n' || *p=='\r'))
			p++;
		if(!p || !*p)
			c_cbuf = NULL;
	} else
		c_cbuf = NULL;

	node = new_method(scope,method,type,oid,gtktypes,id,funcargs,
			  onerror,c_cbuf,line_no,ccode_line,vararg);

	if(cbuf)
		g_string_free(cbuf,
			      /*only free segment if we haven't passed it
				above */
			      c_cbuf?FALSE:TRUE);
	gtktypes = NULL;
	funcargs = NULL;

	class_nodes = g_list_append(class_nodes, node);
}

static void
push_funcarg(char *name, char *postfix)
{
	Node *node;
	Type *type = pop_type();

	type->postfix = postfix;
	
	node = new_funcarg(type,name,checks);
	checks = NULL;
	
	funcargs = g_list_append(funcargs, node);
}

static void
push_init_arg(char *name, int is_class)
{
	Node *node;
	Node *type;
	char *tn;
	
	if(is_class)
		tn = g_strconcat(((Class *)class)->otype,":Class",NULL);
	else
		tn = g_strdup(((Class *)class)->otype);

	type = new_type(1,tn,NULL);
	node = new_funcarg((Type *)type,name,NULL);
	funcargs = g_list_prepend(funcargs, node);
}

static void
push_self(char *id)
{
	Node *node;
	Node *type;
	GList *ch = NULL;
	type = new_type(1,g_strdup(((Class *)class)->otype),NULL);
	ch = g_list_append(ch,new_check(NULL_CHECK,NULL));
	ch = g_list_append(ch,new_check(TYPE_CHECK,NULL));
	node = new_funcarg((Type *)type,id,ch);
	funcargs = g_list_prepend(funcargs, node);
}


#line 201 "parse.y"
typedef union {
	char *id;
	GString *cbuf;
	GList *list;
	int line;
	int sigtype;
} YYSTYPE;
#ifndef YYDEBUG
#define YYDEBUG 1
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		221
#define	YYFLAG		-32768
#define	YYNTBASE	48

#define YYTRANSLATE(x) ((unsigned)(x) <= 288 ? yytranslate[x] : 80)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    46,     2,     2,     2,     2,     2,     2,    38,
    39,    41,     2,    42,    47,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,    37,    44,
    45,    43,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    35,    40,    36,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     4,     7,    10,    12,    14,    16,    18,    20,    23,
    25,    30,    34,    39,    42,    45,    48,    50,    52,    54,
    56,    58,    60,    65,    71,    83,    92,    98,   100,   104,
   105,   109,   111,   113,   116,   118,   121,   124,   127,   129,
   132,   135,   137,   139,   141,   143,   146,   148,   150,   153,
   155,   158,   160,   162,   164,   166,   168,   171,   173,   176,
   178,   182,   186,   189,   191,   196,   200,   202,   205,   207,
   217,   228,   238,   248,   257,   269,   278,   284,   287,   291,
   292,   294,   296,   300,   302,   306,   308,   312,   314,   317,
   321,   328,   336,   339,   341,   343,   346,   349,   353,   357,
   361,   365,   367,   370
};

static const short yyrhs[] = {    50,
    51,    50,     0,    51,    50,     0,    50,    51,     0,    51,
     0,    24,     0,    27,     0,    25,     0,    26,     0,    50,
    49,     0,    49,     0,    52,    35,    53,    36,     0,    52,
    35,    36,     0,     3,    22,     4,    22,     0,    53,    71,
     0,    53,    55,     0,    53,    56,     0,    71,     0,    55,
     0,    56,     0,    28,     0,    29,     0,    30,     0,    54,
    60,    20,    37,     0,    54,    60,    20,    23,    37,     0,
    31,    58,    57,    20,    20,    35,    24,    20,    35,    24,
    37,     0,    31,    58,    57,    20,    20,    35,    24,    37,
     0,    20,    38,    20,    60,    39,     0,    20,     0,    38,
    59,    39,     0,     0,    20,    40,    59,     0,    20,     0,
    61,     0,     5,    61,     0,    62,     0,    62,    65,     0,
    12,    63,     0,    11,    63,     0,    63,     0,    12,    18,
     0,    11,    18,     0,    18,     0,    17,     0,    16,     0,
    20,     0,    64,    20,     0,    22,     0,     6,     0,    13,
    15,     0,    13,     0,    14,    15,     0,    14,     0,    15,
     0,     9,     0,     8,     0,     7,     0,    41,    65,     0,
    41,     0,    20,    68,     0,    68,     0,    54,    20,    68,
     0,    20,    54,    68,     0,    54,    68,     0,    66,     0,
    20,    38,    69,    39,     0,    69,    42,    20,     0,    20,
     0,    35,    24,     0,    37,     0,    33,    67,    60,    20,
    38,    73,    39,    72,    70,     0,    54,    33,    66,    60,
    20,    38,    73,    39,    72,    70,     0,    32,    54,    60,
    20,    38,    73,    39,    72,    70,     0,    54,    32,    60,
    20,    38,    73,    39,    72,    70,     0,    32,    60,    20,
    38,    73,    39,    72,    70,     0,    34,    38,    22,    39,
    60,    20,    38,    73,    39,    72,    70,     0,    54,    60,
    20,    38,    73,    39,    72,    70,     0,    20,    38,    20,
    39,    70,     0,    19,    79,     0,    19,    35,    24,     0,
     0,     6,     0,    20,     0,    20,    42,    74,     0,    74,
     0,    75,    42,    10,     0,    75,     0,    75,    42,    76,
     0,    76,     0,    60,    20,     0,    60,    20,    23,     0,
    60,    20,    38,    20,    77,    39,     0,    60,    20,    23,
    38,    20,    77,    39,     0,    77,    78,     0,    78,     0,
    20,     0,    43,    79,     0,    44,    79,     0,    43,    45,
    79,     0,    44,    45,    79,     0,    45,    45,    79,     0,
    46,    45,    79,     0,    21,     0,    47,    21,     0,    20,
     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   220,   221,   222,   223,   226,   232,   238,   244,   252,   253,
   256,   261,   268,   273,   274,   275,   276,   277,   278,   281,
   282,   283,   286,   289,   293,   328,   358,   367,   373,   374,
   377,   380,   386,   387,   395,   399,   406,   409,   412,   415,
   418,   421,   424,   427,   430,   433,   437,   440,   445,   448,
   451,   454,   457,   462,   465,   468,   473,   474,   478,   490,
   496,   508,   520,   523,   529,   534,   537,   542,   543,   547,
   557,   567,   577,   587,   597,   603,   608,   629,   630,   634,
   637,   638,   649,   659,   662,   663,   666,   667,   670,   673,
   676,   684,   694,   695,   698,   711,   715,   719,   723,   727,
   731,   737,   738,   742
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","CLASS",
"FROM","CONST","VOID","STRUCT","UNION","ENUM","THREEDOTS","SIGNED","UNSIGNED",
"LONG","SHORT","INT","FLOAT","DOUBLE","CHAR","ONERROR","TOKEN","NUMBER","TYPETOKEN",
"ARRAY_DIM","CCODE","HTCODE","PHCODE","HCODE","PUBLIC","PRIVATE","PROTECTED",
"ARGUMENT","VIRTUAL","SIGNAL","OVERRIDE","'{'","'}'","';'","'('","')'","'|'",
"'*'","','","'>'","'<'","'='","'!'","'-'","prog","ccode","ccodes","class","classdec",
"classcode","scope","variable","argument","argtype","argflags","flaglist","type",
"type1","type2","integer","tspecifier","stars","simplesigtype","fullsigtype",
"sigtype","tokenlist","codenocode","method","onerror","funcargs","arglist","arglist1",
"arg","checklist","check","numtok", NULL
};
#endif

static const short yyr1[] = {     0,
    48,    48,    48,    48,    49,    49,    49,    49,    50,    50,
    51,    51,    52,    53,    53,    53,    53,    53,    53,    54,
    54,    54,    55,    55,    56,    56,    57,    57,    58,    58,
    59,    59,    60,    60,    61,    61,    62,    62,    62,    62,
    62,    62,    62,    62,    62,    62,    62,    62,    63,    63,
    63,    63,    63,    64,    64,    64,    65,    65,    66,    66,
    67,    67,    67,    67,    68,    69,    69,    70,    70,    71,
    71,    71,    71,    71,    71,    71,    71,    72,    72,    72,
    73,    73,    73,    73,    74,    74,    75,    75,    76,    76,
    76,    76,    77,    77,    78,    78,    78,    78,    78,    78,
    78,    79,    79,    79
};

static const short yyr2[] = {     0,
     3,     2,     2,     1,     1,     1,     1,     1,     2,     1,
     4,     3,     4,     2,     2,     2,     1,     1,     1,     1,
     1,     1,     4,     5,    11,     8,     5,     1,     3,     0,
     3,     1,     1,     2,     1,     2,     2,     2,     1,     2,
     2,     1,     1,     1,     1,     2,     1,     1,     2,     1,
     2,     1,     1,     1,     1,     1,     2,     1,     2,     1,
     3,     3,     2,     1,     4,     3,     1,     2,     1,     9,
    10,     9,     9,     8,    11,     8,     5,     2,     3,     0,
     1,     1,     3,     1,     3,     1,     3,     1,     2,     3,
     6,     7,     2,     1,     1,     2,     2,     3,     3,     3,
     3,     1,     2,     1
};

static const short yydefact[] = {     0,
     0,     5,     7,     8,     6,    10,     0,     4,     0,     0,
     9,     3,     2,     0,     0,     1,     0,    20,    21,    22,
    30,     0,     0,     0,    12,     0,     0,    18,    19,    17,
    13,     0,     0,     0,     0,    48,    56,    55,    54,     0,
     0,    50,    52,    53,    44,    43,    42,    45,    47,     0,
     0,    33,    35,    39,     0,     0,     0,    64,     0,    60,
     0,    11,    15,    16,    14,     0,     0,     0,     0,    32,
     0,    28,     0,    34,    41,    38,    40,    37,    49,    51,
     0,     0,    58,    36,    46,     0,     0,     0,    59,     0,
    63,     0,     0,     0,     0,     0,     0,     0,     0,    29,
     0,     0,     0,     0,    57,    67,     0,    62,    61,     0,
     0,     0,     0,     0,    23,     0,     0,    69,    77,    31,
     0,     0,     0,    48,    45,     0,     0,    84,    86,    88,
    65,     0,     0,     0,     0,     0,    24,     0,    68,     0,
     0,     0,     0,    89,    80,     0,    66,     0,     0,     0,
     0,    80,    27,     0,    80,    83,    90,     0,     0,     0,
    85,    87,    80,     0,    80,     0,     0,     0,    26,     0,
     0,     0,   104,   102,     0,     0,    78,    74,     0,     0,
     0,    80,    76,     0,    72,     0,    95,     0,     0,     0,
     0,     0,    94,    79,   103,    70,    80,    73,     0,     0,
     0,     0,    96,     0,    97,     0,     0,    91,    93,     0,
    71,    25,    92,    98,    99,   100,   101,    75,     0,     0,
     0
};

static const short yydefgoto[] = {   219,
     6,     7,     8,     9,    26,    27,    28,    29,    73,    34,
    71,   126,    52,    53,    54,    55,    84,    58,    59,    60,
   107,   119,    30,   160,   127,   128,   129,   130,   192,   193,
   177
};

static const short yypact[] = {    21,
   -12,-32768,-32768,-32768,-32768,-32768,    21,   238,     0,    39,
-32768,   238,   238,   202,    41,   238,    84,-32768,-32768,-32768,
   100,   112,   117,   101,-32768,   217,    53,-32768,-32768,-32768,
-32768,    74,    81,   123,   203,-32768,-32768,-32768,-32768,   226,
   241,   129,   133,-32768,-32768,-32768,-32768,-32768,-32768,   168,
   130,-32768,   111,-32768,   149,     1,   151,-32768,   168,-32768,
   156,-32768,-32768,-32768,-32768,   168,   167,   169,   157,   165,
   174,   188,   187,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
   208,   191,   111,-32768,-32768,   204,   223,   237,-32768,    -6,
-32768,   240,   227,   247,    -6,   168,    55,    96,    81,-32768,
   248,   249,   232,   186,-32768,-32768,   -30,-32768,-32768,   233,
   168,   234,   253,   239,-32768,   186,   250,-32768,-32768,-32768,
   168,   242,   186,   236,   185,   258,   243,-32768,   244,-32768,
-32768,   259,   186,   260,   186,   246,-32768,   251,-32768,   252,
   257,   254,   168,    64,   264,   150,-32768,   255,   261,   256,
   186,   264,-32768,    -4,   264,-32768,   262,   265,    56,    96,
-32768,-32768,   264,   186,   264,   263,    96,   266,-32768,    96,
   267,    52,-32768,-32768,   268,   275,-32768,-32768,    96,   269,
    96,   264,-32768,   273,-32768,    52,-32768,    35,    63,   270,
   271,    61,-32768,-32768,-32768,-32768,   264,-32768,    96,   272,
    70,     6,-32768,     6,-32768,     6,     6,-32768,-32768,    96,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   288,   289,
-32768
};

static const short yypgoto[] = {-32768,
   245,    30,   291,-32768,-32768,   -20,   277,   278,-32768,-32768,
   206,   -22,   276,-32768,    71,-32768,   224,   274,-32768,   -38,
-32768,  -159,   280,  -148,  -110,   170,-32768,   164,   126,  -113,
   -53
};


#define	YYLAST		341


static const short yytable[] = {    51,
   178,    50,    57,   167,    68,   138,   170,   183,   131,    10,
   185,   132,   142,    86,   179,   168,   181,    89,    91,   196,
    86,   198,   148,     1,   150,   173,   174,    81,    18,    19,
    20,    87,   169,   199,    14,    88,    92,    13,    87,   211,
   166,    16,    15,    94,     2,     3,     4,     5,   210,   108,
   218,   109,   176,   180,   173,   174,    89,    35,    36,    37,
    38,    39,    31,    40,    41,    42,    43,    44,    45,    46,
    47,   187,    48,   113,    49,   173,   174,   114,   209,   202,
   187,   176,   173,   174,    66,    67,   157,   209,   134,   187,
   175,   115,   116,    69,   188,   189,   190,   191,   140,   208,
    70,   158,   176,   188,   189,   190,   191,   204,   213,   176,
    76,    78,   188,   189,   190,   191,    35,    36,    37,    38,
    39,    32,    40,    41,    42,    43,    44,    45,    46,    47,
   117,    48,   118,    49,   203,   205,    56,    33,    61,    18,
    19,    20,    72,    79,    18,    19,    20,    80,   214,    82,
   215,    83,   216,   217,    35,    36,    37,    38,    39,   161,
    40,    41,    42,    43,    44,    45,    46,    47,    85,    48,
    90,    49,    35,    36,    37,    38,    39,    93,    40,    41,
    42,    43,    44,    45,    46,    47,    95,    48,    97,    49,
    35,   124,    37,    38,    39,    98,    40,    41,    42,    43,
    44,    45,    46,    47,    99,   125,   102,    49,    36,    37,
    38,    39,   100,    40,    41,    42,    43,    44,    45,    46,
    47,    17,    48,   -82,    49,   101,   143,   103,   104,    18,
    19,    20,    21,    22,    23,    24,    17,    25,    42,    43,
    44,    87,   106,    75,    18,    19,    20,    21,    22,    23,
    24,    11,    62,    42,    43,    44,    86,    11,    77,   110,
    11,     2,     3,     4,     5,   111,   112,   121,   122,   123,
   133,   135,   136,   139,   -81,   137,   141,   144,   147,   149,
   154,   145,   159,   151,   172,   146,   186,   220,   221,   152,
   153,   194,   155,   163,   165,   195,   200,    12,   164,   171,
   184,   182,    63,    64,   120,    65,   105,   197,   212,   162,
    74,   201,   156,     0,   206,   207,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    96
};

static const short yycheck[] = {    22,
   160,    22,    23,   152,    27,   116,   155,   167,    39,    22,
   170,    42,   123,    20,   163,    20,   165,    56,    57,   179,
    20,   181,   133,     3,   135,    20,    21,    50,    28,    29,
    30,    38,    37,   182,    35,    56,    59,     8,    38,   199,
   151,    12,     4,    66,    24,    25,    26,    27,   197,    88,
   210,    90,    47,   164,    20,    21,    95,     5,     6,     7,
     8,     9,    22,    11,    12,    13,    14,    15,    16,    17,
    18,    20,    20,    96,    22,    20,    21,    23,   192,    45,
    20,    47,    20,    21,    32,    33,    23,   201,   111,    20,
    35,    37,    38,    20,    43,    44,    45,    46,   121,    39,
    20,    38,    47,    43,    44,    45,    46,    45,    39,    47,
    40,    41,    43,    44,    45,    46,     5,     6,     7,     8,
     9,    38,    11,    12,    13,    14,    15,    16,    17,    18,
    35,    20,    37,    22,   188,   189,    20,    38,    38,    28,
    29,    30,    20,    15,    28,    29,    30,    15,   202,    20,
   204,    41,   206,   207,     5,     6,     7,     8,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    20,    20,
    20,    22,     5,     6,     7,     8,     9,    22,    11,    12,
    13,    14,    15,    16,    17,    18,    20,    20,    20,    22,
     5,     6,     7,     8,     9,    39,    11,    12,    13,    14,
    15,    16,    17,    18,    40,    20,    20,    22,     6,     7,
     8,     9,    39,    11,    12,    13,    14,    15,    16,    17,
    18,    20,    20,    39,    22,    38,    42,    20,    38,    28,
    29,    30,    31,    32,    33,    34,    20,    36,    13,    14,
    15,    38,    20,    18,    28,    29,    30,    31,    32,    33,
    34,     7,    36,    13,    14,    15,    20,    13,    18,    20,
    16,    24,    25,    26,    27,    39,    20,    20,    20,    38,
    38,    38,    20,    24,    39,    37,    35,    20,    20,    20,
    24,    39,    19,    38,    20,    42,    20,     0,     0,    39,
    39,    24,    39,    39,    39,    21,    24,     7,    38,    38,
    35,    39,    26,    26,    99,    26,    83,    39,    37,   146,
    35,   186,   143,    -1,    45,    45,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    67
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 220 "parse.y"
{ ; ;
    break;}
case 2:
#line 221 "parse.y"
{ ; ;
    break;}
case 3:
#line 222 "parse.y"
{ ; ;
    break;}
case 4:
#line 223 "parse.y"
{ ; ;
    break;}
case 5:
#line 226 "parse.y"
{
			Node *node = new_ccode(C_CCODE,(yyvsp[0].cbuf)->str,
					       ccode_line);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 6:
#line 232 "parse.y"
{
			Node *node = new_ccode(H_CCODE,(yyvsp[0].cbuf)->str,
					       ccode_line);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 7:
#line 238 "parse.y"
{
			Node *node = new_ccode(HT_CCODE,(yyvsp[0].cbuf)->str,
					       ccode_line);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 8:
#line 244 "parse.y"
{
			Node *node = new_ccode(PH_CCODE,(yyvsp[0].cbuf)->str,
					       ccode_line);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 9:
#line 252 "parse.y"
{ ; ;
    break;}
case 10:
#line 253 "parse.y"
{ ; ;
    break;}
case 11:
#line 256 "parse.y"
{
			((Class *)class)->nodes = class_nodes;
			class_nodes = NULL;
			nodes = g_list_append(nodes,class);
						;
    break;}
case 12:
#line 261 "parse.y"
{
			((Class *)class)->nodes = NULL;
			class_nodes = NULL;
			nodes = g_list_append(nodes,class);
						;
    break;}
case 13:
#line 268 "parse.y"
{
			class = new_class(yyvsp[-2].id,yyvsp[0].id,NULL);
						;
    break;}
case 14:
#line 273 "parse.y"
{ ; ;
    break;}
case 15:
#line 274 "parse.y"
{ ; ;
    break;}
case 16:
#line 275 "parse.y"
{ ; ;
    break;}
case 17:
#line 276 "parse.y"
{ ; ;
    break;}
case 18:
#line 277 "parse.y"
{ ; ;
    break;}
case 19:
#line 278 "parse.y"
{ ; ;
    break;}
case 20:
#line 281 "parse.y"
{ the_scope = PUBLIC_SCOPE; ;
    break;}
case 21:
#line 282 "parse.y"
{ the_scope = PRIVATE_SCOPE; ;
    break;}
case 22:
#line 283 "parse.y"
{ the_scope = PROTECTED_SCOPE; ;
    break;}
case 23:
#line 286 "parse.y"
{
			push_variable(yyvsp[-1].id,the_scope,yyvsp[-3].line,NULL);
						;
    break;}
case 24:
#line 289 "parse.y"
{
			push_variable(yyvsp[-2].id,the_scope,yyvsp[-4].line,yyvsp[-1].id);
						;
    break;}
case 25:
#line 293 "parse.y"
{
			if(strcmp(yyvsp[-6].id,"get")==0 &&
			   strcmp(yyvsp[-3].id,"set")==0) {
				Node *node;
				Type *type = pop_type();
				g_free(yyvsp[-6].id); g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-8].id,type,yyvsp[-9].list,yyvsp[-7].id,
						    (yyvsp[-4].cbuf)->str,yyvsp[-5].line,
						    (yyvsp[-1].cbuf)->str,yyvsp[-2].line,
						    yyvsp[-10].line);
				g_string_free(yyvsp[-4].cbuf,FALSE);
				g_string_free(yyvsp[-1].cbuf,FALSE);
				class_nodes = g_list_append(class_nodes,node);
			} else if(strcmp(yyvsp[-6].id,"set")==0 &&
				strcmp(yyvsp[-3].id,"get")==0) {
				Node *node;
				Type *type = pop_type();
				g_free(yyvsp[-6].id); g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-8].id,type,yyvsp[-9].list,yyvsp[-7].id,
						    (yyvsp[-1].cbuf)->str,yyvsp[-2].line,
						    (yyvsp[-4].cbuf)->str,yyvsp[-5].line,
						    yyvsp[-10].line);
				g_string_free(yyvsp[-1].cbuf,FALSE);
				g_string_free(yyvsp[-4].cbuf,FALSE);
				class_nodes = g_list_append(class_nodes,node);
			} else {
				g_free(yyvsp[-8].id); g_free(yyvsp[-7].id);
				g_free(yyvsp[-6].id); g_free(yyvsp[-3].id);
				g_list_foreach(yyvsp[-9].list,(GFunc)g_free,NULL);
				g_string_free(yyvsp[-1].cbuf,TRUE);
				g_string_free(yyvsp[-4].cbuf,TRUE);
				yyerror(_("parse error"));
				YYERROR;
			}
						;
    break;}
case 26:
#line 328 "parse.y"
{
			if(strcmp(yyvsp[-3].id,"get")==0) {
				Node *node;
				Type *type = pop_type();
				g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-5].id,type,yyvsp[-6].list,yyvsp[-4].id,
						    (yyvsp[-1].cbuf)->str,yyvsp[-2].line,
						    NULL,0, yyvsp[-7].line);
				g_string_free(yyvsp[-1].cbuf,FALSE);
				class_nodes = g_list_append(class_nodes,node);
			} else if(strcmp(yyvsp[-3].id,"set")==0) {
				Node *node;
				Type *type = pop_type();
				g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-5].id,type,yyvsp[-6].list,yyvsp[-4].id,
						    NULL,0,(yyvsp[-1].cbuf)->str,
						    yyvsp[-2].line, yyvsp[-7].line);
				g_string_free(yyvsp[-1].cbuf,FALSE);
				class_nodes = g_list_append(class_nodes,node);
			} else {
				g_free(yyvsp[-3].id); g_free(yyvsp[-5].id);
				g_free(yyvsp[-4].id);
				g_list_foreach(yyvsp[-6].list,(GFunc)g_free,NULL);
				g_string_free(yyvsp[-1].cbuf,TRUE);
				yyerror(_("parse error"));
				YYERROR;
			}
						;
    break;}
case 27:
#line 358 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"type")!=0) {
				g_free(yyvsp[-4].id);
				g_free(yyvsp[-2].id);
				yyerror(_("parse error"));
				YYERROR;
			}
			yyval.id = yyvsp[-4].id;
						;
    break;}
case 28:
#line 367 "parse.y"
{
			yyval.id = yyvsp[0].id;
			typestack = g_list_prepend(typestack,NULL);
						;
    break;}
case 29:
#line 373 "parse.y"
{ yyval.list = yyvsp[-1].list; ;
    break;}
case 30:
#line 374 "parse.y"
{ yyval.list = NULL; ;
    break;}
case 31:
#line 377 "parse.y"
{
			yyval.list = g_list_append(yyvsp[0].list,yyvsp[-2].id);
						;
    break;}
case 32:
#line 380 "parse.y"
{
			yyval.list = g_list_append(NULL,yyvsp[0].id);
						;
    break;}
case 33:
#line 386 "parse.y"
{ ; ;
    break;}
case 34:
#line 387 "parse.y"
{
			Type *type = typestack->data;
			char *oldname = type->name;
			type->name = g_strconcat("const ",oldname,NULL);
			g_free(oldname);
						;
    break;}
case 35:
#line 395 "parse.y"
{
			Node *node = new_type(0,yyvsp[0].id,NULL);
			typestack = g_list_prepend(typestack,node);
						;
    break;}
case 36:
#line 399 "parse.y"
{
			Node *node = new_type(stars,yyvsp[-1].id,NULL);
			stars = 0;
			typestack = g_list_prepend(typestack,node);
						;
    break;}
case 37:
#line 406 "parse.y"
{
			yyval.id = g_strconcat("unsigned ",yyvsp[0].id,NULL);
						;
    break;}
case 38:
#line 409 "parse.y"
{
			yyval.id = g_strconcat("signed ",yyvsp[0].id,NULL);
						;
    break;}
case 39:
#line 412 "parse.y"
{
			yyval.id = g_strdup(yyvsp[0].id);
						;
    break;}
case 40:
#line 415 "parse.y"
{
			yyval.id = g_strdup("unsigned char");
						;
    break;}
case 41:
#line 418 "parse.y"
{
			yyval.id = g_strdup("signed char");
						;
    break;}
case 42:
#line 421 "parse.y"
{
			yyval.id = g_strdup("char");
						;
    break;}
case 43:
#line 424 "parse.y"
{
			yyval.id = g_strdup("double");
						;
    break;}
case 44:
#line 427 "parse.y"
{
			yyval.id = g_strdup("float");
						;
    break;}
case 45:
#line 430 "parse.y"
{
			yyval.id = yyvsp[0].id;
						;
    break;}
case 46:
#line 433 "parse.y"
{
			yyval.id = g_strconcat(yyvsp[-1].id,yyvsp[0].id,NULL);
			g_free(yyvsp[0].id);
						;
    break;}
case 47:
#line 437 "parse.y"
{
			yyval.id = yyvsp[0].id;
						;
    break;}
case 48:
#line 440 "parse.y"
{
			yyval.id = g_strdup("void");
						;
    break;}
case 49:
#line 445 "parse.y"
{
			yyval.id = "long int";
						;
    break;}
case 50:
#line 448 "parse.y"
{
			yyval.id = "long";
						;
    break;}
case 51:
#line 451 "parse.y"
{
			yyval.id = "short int";
						;
    break;}
case 52:
#line 454 "parse.y"
{
			yyval.id = "short";
						;
    break;}
case 53:
#line 457 "parse.y"
{
			yyval.id = "int";
						;
    break;}
case 54:
#line 462 "parse.y"
{
			yyval.id = "enum ";
						;
    break;}
case 55:
#line 465 "parse.y"
{
			yyval.id = "union ";
						;
    break;}
case 56:
#line 468 "parse.y"
{
			yyval.id = "struct ";
						;
    break;}
case 57:
#line 473 "parse.y"
{ stars++; ;
    break;}
case 58:
#line 474 "parse.y"
{ stars++; ;
    break;}
case 59:
#line 478 "parse.y"
{
			if(strcmp(yyvsp[-1].id,"first")==0)
				yyval.sigtype = SIGNAL_FIRST_METHOD;
			else if(strcmp(yyvsp[-1].id,"last")==0)
				yyval.sigtype = SIGNAL_LAST_METHOD;
			else {
				yyerror(_("signal must be 'first' or 'last'"));
				g_free(yyvsp[-1].id);
				YYERROR;
			}
			g_free(yyvsp[-1].id);
					;
    break;}
case 60:
#line 490 "parse.y"
{
			yyval.sigtype = SIGNAL_LAST_METHOD;
					;
    break;}
case 61:
#line 496 "parse.y"
{
			if(strcmp(yyvsp[-1].id,"first")==0)
				yyval.sigtype = SIGNAL_FIRST_METHOD;
			else if(strcmp(yyvsp[-1].id,"last")==0)
				yyval.sigtype = SIGNAL_LAST_METHOD;
			else {
				yyerror(_("signal must be 'first' or 'last'"));
				g_free(yyvsp[-1].id);
				YYERROR;
			}
			g_free(yyvsp[-1].id);
					;
    break;}
case 62:
#line 508 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"first")==0)
				yyval.sigtype = SIGNAL_FIRST_METHOD;
			else if(strcmp(yyvsp[-2].id,"last")==0)
				yyval.sigtype = SIGNAL_LAST_METHOD;
			else {
				yyerror(_("signal must be 'first' or 'last'"));
				g_free(yyvsp[-2].id);
				YYERROR;
			}
			g_free(yyvsp[-2].id);
					;
    break;}
case 63:
#line 520 "parse.y"
{
			yyval.sigtype = SIGNAL_LAST_METHOD;
					;
    break;}
case 64:
#line 523 "parse.y"
{
			/* the_scope was default thus public */
			the_scope = PUBLIC_SCOPE;
					;
    break;}
case 65:
#line 529 "parse.y"
{
			gtktypes = g_list_prepend(gtktypes,yyvsp[-3].id);
						;
    break;}
case 66:
#line 534 "parse.y"
{
			gtktypes = g_list_append(gtktypes,yyvsp[0].id);
						;
    break;}
case 67:
#line 537 "parse.y"
{ 
			gtktypes = g_list_append(gtktypes,yyvsp[0].id);
       						;
    break;}
case 68:
#line 542 "parse.y"
{ yyval.cbuf = yyvsp[0].cbuf; ;
    break;}
case 69:
#line 543 "parse.y"
{ yyval.cbuf = NULL; ;
    break;}
case 70:
#line 547 "parse.y"
{
			if(!has_self) {
				yyerror(_("signal without 'self' as "
					  "first parameter"));
				YYERROR;
			}
			push_function(the_scope, yyvsp[-7].sigtype,NULL,
				      yyvsp[-5].id, yyvsp[-1].id, yyvsp[0].cbuf,yyvsp[-8].line,
				      ccode_line,vararg);
									;
    break;}
case 71:
#line 557 "parse.y"
{
			if(!has_self) {
				yyerror(_("signal without 'self' as "
					  "first parameter"));
				YYERROR;
			}
			push_function(the_scope, yyvsp[-7].sigtype,NULL,
				      yyvsp[-5].id, yyvsp[-1].id, yyvsp[0].cbuf,yyvsp[-8].line,
				      ccode_line,vararg);
									;
    break;}
case 72:
#line 567 "parse.y"
{
			if(!has_self) {
				yyerror(_("virtual method without 'self' as "
					  "first parameter"));
				YYERROR;
			}
			push_function(the_scope, VIRTUAL_METHOD, NULL, yyvsp[-5].id,
				      yyvsp[-1].id, yyvsp[0].cbuf,yyvsp[-8].line,
				      ccode_line,vararg);
									;
    break;}
case 73:
#line 577 "parse.y"
{
			if(!has_self) {
				yyerror(_("virtual method without 'self' as "
					  "first parameter"));
				YYERROR;
			}
			push_function(the_scope, VIRTUAL_METHOD, NULL, yyvsp[-5].id,
				      yyvsp[-1].id, yyvsp[0].cbuf,yyvsp[-7].line,
				      ccode_line,vararg);
									;
    break;}
case 74:
#line 587 "parse.y"
{
			if(!has_self) {
				yyerror(_("virtual method without 'self' as "
					  "first parameter"));
				YYERROR;
			}
			push_function(PUBLIC_SCOPE, VIRTUAL_METHOD, NULL,
				      yyvsp[-5].id, yyvsp[-1].id, yyvsp[0].cbuf,yyvsp[-7].line,
				      ccode_line,vararg);
									;
    break;}
case 75:
#line 597 "parse.y"
{
			push_function(NO_SCOPE, OVERRIDE_METHOD, yyvsp[-8].id,
				      yyvsp[-5].id, yyvsp[-1].id, yyvsp[0].cbuf,
				      yyvsp[-10].line,ccode_line,
				      vararg);
									;
    break;}
case 76:
#line 603 "parse.y"
{
			push_function(the_scope, REGULAR_METHOD, NULL, yyvsp[-5].id,
				      yyvsp[-1].id, yyvsp[0].cbuf,yyvsp[-7].line,ccode_line,
				      vararg);
								;
    break;}
case 77:
#line 608 "parse.y"
{
			if(strcmp(yyvsp[-4].id,"init")==0) {
				push_init_arg(yyvsp[-2].id,FALSE);
				push_function(NO_SCOPE, INIT_METHOD, NULL,
					      yyvsp[-4].id, NULL, yyvsp[0].cbuf,yyvsp[-3].line,
					      ccode_line,FALSE);
			} else if(strcmp(yyvsp[-4].id,"class_init")==0) {
				push_init_arg(yyvsp[-2].id,TRUE);
				push_function(NO_SCOPE, CLASS_INIT_METHOD, NULL,
					      yyvsp[-4].id, NULL, yyvsp[0].cbuf,yyvsp[-3].line,
					      ccode_line,FALSE);
			} else {
				g_free(yyvsp[-4].id);
				g_free(yyvsp[-2].id);
				g_string_free(yyvsp[-2].cbuf,TRUE);
				yyerror(_("parse error"));
				YYERROR;
			}
						;
    break;}
case 78:
#line 629 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
case 79:
#line 630 "parse.y"
{
			yyval.id = (yyvsp[0].cbuf)->str;
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 80:
#line 634 "parse.y"
{ yyval.id = NULL; ;
    break;}
case 81:
#line 637 "parse.y"
{ vararg = FALSE; has_self = FALSE; ;
    break;}
case 82:
#line 638 "parse.y"
{
			vararg = FALSE;
			has_self = TRUE;
			if(strcmp(yyvsp[0].id,"self")==0)
				push_self(yyvsp[0].id);
			else {
				g_free(yyvsp[0].id);
				yyerror(_("parse error"));
				YYERROR;
			}
       					;
    break;}
case 83:
#line 649 "parse.y"
{
			has_self = TRUE;
			if(strcmp(yyvsp[-2].id,"self")==0)
				push_self(yyvsp[-2].id);
			else {
				g_free(yyvsp[-2].id);
				yyerror(_("parse error"));
				YYERROR;
			}
					;
    break;}
case 84:
#line 659 "parse.y"
{ has_self = FALSE; ;
    break;}
case 85:
#line 662 "parse.y"
{ vararg = TRUE; ;
    break;}
case 86:
#line 663 "parse.y"
{ vararg = FALSE; ;
    break;}
case 87:
#line 666 "parse.y"
{ ; ;
    break;}
case 88:
#line 667 "parse.y"
{ ; ;
    break;}
case 89:
#line 670 "parse.y"
{
			push_funcarg(yyvsp[0].id,NULL);
								;
    break;}
case 90:
#line 673 "parse.y"
{
			push_funcarg(yyvsp[-1].id,yyvsp[0].id);
								;
    break;}
case 91:
#line 676 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"check")!=0) {
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[-2].id);
			push_funcarg(yyvsp[-4].id,NULL);
								;
    break;}
case 92:
#line 684 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"check")!=0) {
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[-2].id);
			push_funcarg(yyvsp[-5].id,yyvsp[-4].id);
								;
    break;}
case 93:
#line 694 "parse.y"
{ ; ;
    break;}
case 94:
#line 695 "parse.y"
{ ; ;
    break;}
case 95:
#line 698 "parse.y"
{
			if(strcmp(yyvsp[0].id,"type")==0) {
				Node *node = new_check(TYPE_CHECK,NULL);
				checks = g_list_append(checks,node);
			} else if(strcmp(yyvsp[0].id,"null")==0) {
				Node *node = new_check(NULL_CHECK,NULL);
				checks = g_list_append(checks,node);
			} else {
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[0].id);
					;
    break;}
case 96:
#line 711 "parse.y"
{
			Node *node = new_check(GT_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 97:
#line 715 "parse.y"
{
			Node *node = new_check(LT_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 98:
#line 719 "parse.y"
{
			Node *node = new_check(GE_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 99:
#line 723 "parse.y"
{
			Node *node = new_check(LE_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 100:
#line 727 "parse.y"
{
			Node *node = new_check(EQ_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 101:
#line 731 "parse.y"
{
			Node *node = new_check(NE_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 102:
#line 737 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
case 103:
#line 738 "parse.y"
{
			yyval.id = g_strconcat("-",yyvsp[0].id,NULL);
			g_free(yyvsp[0].id);
					;
    break;}
case 104:
#line 742 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 745 "parse.y"

